HDU 5542 The Battle of Chibi(DP+树状数组)

时间:2022-04-24 19:27:36

思路:求递增子序列个数为M的方案数,显然有一个很简单的DP是dp[i][j]=sum(dp[i-1][k]) (a[k]<a[j]&&1<=k<j),然后这是n^3的,所以用一个树状数组和离散化优化到n^2logn就可以了


#include<bits/stdc++.h>
using namespace std;
const int maxn = 1005;
const int mod = 1e9+7;
#define LL long long
int dp[maxn][maxn];
int a[maxn],b[maxn];
vector<int>v;
int lowbit(int x){return x&(-x);}
int getid(int x){return lower_bound(v.begin(),v.end(),x)-v.begin()+1;}
int n,m;
void update(int x,int y,int num)
{
	while(y<=maxn)
	{
		dp[x][y]+=num;
		dp[x][y]%=mod;
		y+=lowbit(y);
	}
}
int query(int x,int y)
{
	int ans = 0;
	while(y)
	{
		ans+=dp[x][y];
		ans%=mod;
		y-=lowbit(y);
	}
	return ans;
}
int main()
{
	int T,cas=1;
	scanf("%d",&T);
	while(T--)
	{
		memset(dp,0,sizeof(dp));
        scanf("%d%d",&n,&m);
		for(int i = 1;i<=n;i++)
		{
			scanf("%d",&a[i]);
			b[i]=a[i];
		//	v.push_back(a[i]);
		}
		sort(b+1,b+1+n);
        for(int i = 1;i<=n;i++)
			a[i]=lower_bound(b+1,b+1+n,a[i])-b;

		//v.erase(unique(v.begin(),v.end()),v.end());
        for(int i = 1;i<=n;i++)
		{
			for(int j = 1;j<=m;j++)
			{
				if(j==1)
					update(1,a[i],1);
				else
				{
					int res = query(j-1,a[i]-1);
					update(j,a[i],res);
				}
			}
		}
		int ans = query(m,n);
		printf("Case #%d: ",cas++);
		printf("%d\n",ans);
	}
}


Description

Cao Cao made up a big army and was going to invade the whole South China. Yu Zhou was worried about it. He thought the only way to beat Cao Cao is to have a spy in Cao Cao's army. But all generals and soldiers of Cao Cao were loyal, it's impossible to convince any of them to betray Cao Cao. 

So there is only one way left for Yu Zhou, send someone to fake surrender Cao Cao. Gai Huang was selected for this important mission. However, Cao Cao was not easy to believe others, so Gai Huang must leak some important information to Cao Cao before surrendering. 

Yu Zhou discussed with Gai Huang and worked out  N  information to be leaked, in happening order. Each of the information was estimated to has  a_{i}  value in Cao Cao's opinion. 

Actually, if you leak information with strict increasing value could accelerate making Cao Cao believe you. So Gai Huang decided to leak exact  M  information with strict increasing value in happening order. In other words, Gai Huang will not change the order of the  N information and just select  M  of them. Find out how many ways Gai Huang could do this.
 

Input

The first line of the input gives the number of test cases,  T(1≤100) T  test cases follow. 

Each test case begins with two numbers  N(1≤N≤10^3)  and  M(1≤M≤N) , indicating the number of information and number of information Gai Huang will select. Then  N  numbers in a line, the  i_{th}  number  a_{i}(1≤a_{i}≤10^{9})  indicates the value in Cao Cao's opinion of the  i_{th}  information in happening order.
 

Output

For each test case, output one line containing  Case #x: y, where  x  is the test case number (starting from 1) and  y  is the ways Gai Huang can select the information. 

The result is too large, and you need to output the result mod by  1000000007(10^{9}+7) .
 

Sample Input

 
       
2 3 2 1 2 3 3 2 3 2 1
 

Sample Output

 
       
Case #1: 3 Case #2: 0

Hint

 In the first cases, Gai Huang need to leak 2 information out of 3. He could leak any 2 information as all the information value are in increasing order. In the second cases, Gai Huang has no choice as selecting any 2 information is not in increasing order.